"use strict";

var _path = require("path");
var _os = require("os");

var _ = require("lodash");
var async = require("neo-async");

exports.pages = function (o) {
  return function (finalCb) {
    var data = Object.keys(o.allPages).map(function (page) {
      var p = _path.join(o.output, page);

      return {
        path: p,
        page: page,
        title: o.allPages[page].title
      };
    });

    async.map(data, function (d, cb) {
      // avoid writing index/index.html and write index.html instead
      return cb(null, {
        path: d.path.split("/").slice(-1)[0] === "index" ? _path.join(d.path, "..", "index.html") : _path.join(d.path, "index.html"),
        page: d.page,
        title: d.title
      });
    }, function (err, d) {
      if (err) {
        return finalCb(err);
      }

      return finalCb(null, _.chunk(d, _os.cpus().length).map(function (partition) {
        return {
          output: o.output,
          pages: partition,
          templates: o.templates
        };
      }));
    });
  };
};