"use strict";

var _path = require("path");

var path = _interopRequireWildcard(_path);

var _lodash = require("lodash");

var _lodash2 = _interopRequireDefault(_lodash);

var _rimraf = require("rimraf");

var _rimraf2 = _interopRequireDefault(_rimraf);

var _pretty_console = require("./libs/pretty_console");

var _pretty_console2 = _interopRequireDefault(_pretty_console);

var _build = require("./build");

var _build2 = _interopRequireDefault(_build);

var _dev = require("./dev");

var _dev2 = _interopRequireDefault(_dev);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

require("es6-promise").polyfill();

exports.develop = execute(develop);
exports.start = exports.develop; // convenience alias
exports.build = execute(_build2.default);

function execute(target) {
  return function (_ref) {
    var antwar = _ref.antwar,
        webpack = _ref.webpack,
        environment = _ref.environment;
    return target({
      environment: environment,
      antwar: _lodash2.default.merge(defaultConfiguration(), _lodash2.default.isFunction(antwar) ? antwar(environment) : antwar),
      webpack: webpack(environment)
    });
  };
}

function defaultConfiguration() {
  return {
    port: 3000,
    output: "build",
    console: _pretty_console2.default
  };
}

function develop(configurations) {
  var cwd = process.cwd();
  var buildDir = path.join(cwd, "./.antwar");

  return new Promise(function (resolve, reject) {
    (0, _rimraf2.default)(buildDir, function (err) {
      if (err) {
        return reject(err);
      }

      return _build2.default.devIndex(configurations).then(_dev2.default.server.bind(null, configurations)).then(resolve).catch(reject);
    });
  });
}