"use strict";

var getPageForPath = require("./get-page-for-path");

describe("Get page for path", function () {
  it("gets the root page", function () {
    var result = getPageForPath("/", { "/": "demo" });
    var expected = "demo";

    expect(result).toEqual(expected);
  });

  it("gets an empty object if there is no root", function () {
    var result = getPageForPath("/", {});
    var expected = {};

    expect(result).toEqual(expected);
  });

  it("gets a page", function () {
    var result = getPageForPath("foo/", { "foo/": "demo" });
    var expected = "demo";

    expect(result).toEqual(expected);
  });

  it("gets a page without a trailing slash", function () {
    var result = getPageForPath("foo", { "foo/": "demo" });
    var expected = "demo";

    expect(result).toEqual(expected);
  });

  it("returns an empty object if there is no match", function () {
    var result = getPageForPath("foo", { "bar/": "demo" });
    var expected = {};

    expect(result).toEqual(expected);
  });
});